﻿using Syncfusion.UI.Xaml.Diagram;
using Syncfusion.UI.Xaml.Diagram.Layout;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Data.OleDb;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace _156554_Database
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        OleDbConnection con;
        DataTable dt;
        //Initialize Employee class
        ObservableCollection<Employee> employee { get; set; }

        // Initialize DataSourceSettings
        DataSourceSettings settings = new DataSourceSettings();
        public MainWindow()
        {
            InitializeComponent();
            diagramControl.Nodes = new ObservableCollection<Node>();
            diagramControl.Connectors = new ObservableCollection<Connector>();
            //Connect your access database
            con = new OleDbConnection();
            con.ConnectionString = "Provider=Microsoft.Jet.Oledb.4.0; Data Source=" + AppDomain.CurrentDomain.BaseDirectory + "\\collection.mdb";
            BindGrid();

            //To Disable ContextMenu
            diagramControl.Menu = null;
            diagramControl.Tool = Tool.ZoomPan;
            diagramControl.Constraints = diagramControl.Constraints & ~(GraphConstraints.Zoomable | GraphConstraints.Pannable);
            diagramControl.ScrollSettings.ScrollLimit = ScrollLimit.Diagram;
            diagramControl.PageSettings.PageBorderBrush = new SolidColorBrush(Colors.Transparent);
            diagramControl.PageSettings.PageBackground = new SolidColorBrush(Colors.White);
            diagramControl.PageSettings.MultiplePage = true;
            diagramControl.PageSettings.MultiplePage = true;
        
         }
        private void BindGrid()
        {
            OleDbCommand cmd = new OleDbCommand();
            if (con.State != ConnectionState.Open)
                con.Open();
            cmd.Connection = con;
            cmd.CommandText = "select * from Table1";
            OleDbDataAdapter da = new OleDbDataAdapter(cmd);
            dt = new DataTable();
            da.Fill(dt);
            gvData.ItemsSource = dt.AsDataView();

            if (dt.Rows.Count > 0)
            {
                lblCount.Visibility = System.Windows.Visibility.Hidden;
                gvData.Visibility = System.Windows.Visibility.Visible;
            }
            else
            {
                lblCount.Visibility = System.Windows.Visibility.Visible;
                gvData.Visibility = System.Windows.Visibility.Hidden;
            }
            this.DataContext = gvData;

        }
        

        private void gvData_DataContextChanged(object sender, DependencyPropertyChangedEventArgs e)
        {
            employee = new ObservableCollection<Employee>();

           //Get DataSourceSettings Properties.
            settings.ParentId = "ParentId";
            settings.Id = "EmpId";
            settings.Root = "1";
            if(gvData.Items.Count>0)
            {
      
                for (int i = 0; i < gvData.Items.Count-1;i++ )
                {
                    Employee a = new Employee();
                    DataRowView row =(DataRowView) gvData.Items[i];
                        a.EmpId = row["Empid"].ToString();
                        a.Name = row["Name"].ToString();
                        a.ParentId = row["ParentId"].ToString();
                        a.Designation = row["Designation"].ToString();
                        employee.Add(a);

                }

                settings.DataSource = employee;
                diagramControl.DataSourceSettings = settings;
                diagramControl.LayoutManager = new Syncfusion.UI.Xaml.Diagram.Layout.LayoutManager()
                {
                    Layout = new DirectedTreeLayout()
                };
                (diagramControl.LayoutManager.Layout as DirectedTreeLayout).Margin = new Thickness(400,100,0,0);
             

               
            }

        }
    }
    public class Employee
    {
        public string  EmpId { get; set; }
        public string ParentId { get; set; }
        public string Name { get; set; }
        public string Designation { get; set; }
    }
}
